#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Oct 18 16:23:37 2024

@author: user
"""

V = [1,2,3,4,5,6,7,8,9] #elements
U = [(1,2),(1,6),(2,6),(3,1),(3,7),(4,1),(4,7),(5,2),(5,8),(6,9),(3,8),(8,9)] #partial order
Vc = V.copy()
n = len(V)
pre = [[] for i in range(n+1)] #u in pre[v] <==> (u,v) in U
succ = [[] for i in range(n+1)] #u in succ[v] <==> (v,u) in U
for t in U: #for each tuple t in U
    pre[t[1]].append(t[0]) #populate pre
    succ[t[0]].append(t[1]) #populate succ

L = [] #result is stored in L
while(len(Vc) > 0):
    l = len(Vc)
    for v in Vc: #for each element v 
        if len(pre[v]) == 0: #if v has no predecessor
            L.append(v) #append it in L
            for u in succ[v]: #for each successor u of v
                pre[u].remove(v) #delete v from list of predecessors of u
            #succ[v].clear()      
            Vc.remove(v) #delete v
            break #reset for v loop
    if l == len(Vc): break #no progress => no possible solution  
    
if (len(Vc)==0): print("result:", L)
else: print("no result found")       
